searchNodes=[{"doc":"ExqBatch provides a building block to create complex workflows using Exq jobs. A batch monitors a group of Exq jobs and creates callback job when all the jobs are processed.TelemetryThe following telemetry events are published. progress event is published on each job completion (either dead or done). done is published when the batch is done (all the jobs are either dead or done).[ [:exq_batch, :batch, :new], [:exq_batch, :batch, :add], [:exq_batch, :batch, :create], [:exq_batch, :batch, :progress], [:exq_batch, :batch, :done] ]MeasurementsAll the events include duration in native time unit. Note that duration here measures the time taken for ExqBatch to complete the operation.MetadataAll the events include id attribute (batch id). add and progress events include jid attribute as well.","ref":"ExqBatch.html","title":"ExqBatch","type":"module"},{"doc":"Add a job to the given batch.There are two ways to add a job to batchPass the job params and let ExqBatch enqueue the job. ExqBatch will both enqueue the job and add it to the batch using a atomic MULTI EXEC operation. Refer the on_complete option in new/1 for job options. {:ok, batch, jid} = ExqBatch.add(batch, queue: &quot;default&quot;, class: Worker, args: [1])Add a job using jid. Note that, the add/2 should be called before the job is enqueued. Otherwise, there is a potential race condition where the job could finish before add/2 is called and would cause the batch to hang. Exq allows to specify the jid of the job, so generate a jid first, then add it to the batch and after that enqueue the job. jid = UUID.uuid4() {:ok, batch, ^jid} = ExqBatch.add(batch, jid) {:ok, ^jid} = Exq.enqueue(Exq, &quot;default&quot;, SuccessWorker, [1], jid: jid)","ref":"ExqBatch.html#add/2","title":"ExqBatch.add/2","type":"function"},{"doc":"Finalize the batch creation process.","ref":"ExqBatch.html#create/1","title":"ExqBatch.create/1","type":"function"},{"doc":"Initialize a new batch.on_complete job will receive an extra arg which includes the list of dead and succeeded jids. Example %{&quot;dead&quot; =&gt; [], &quot;succeeded&quot; =&gt; [jid1, jid2]}Optionson_complete (keyword) required - A Keyword list that specifies the details of job that will get enqueued on when all the jobs in a batch get completedqueue (string) required - exq job queueargs (array) required - exq job args.class (string) required - exq job class.retry (integer) - no of times the job should be retried.jid (string) - if not present, A UUID is used.id (string) - A UUID is used by default. If same id is used for two batch jobs, the previous batch jobs will get cleared.","ref":"ExqBatch.html#new/1","title":"ExqBatch.new/1","type":"function"},{"doc":"","ref":"ExqBatch.html#t:t/0","title":"ExqBatch.t/0","type":"type"},{"doc":"Monitors job life cycle and creates completion job when all job in a batch is done.","ref":"ExqBatch.Middleware.html","title":"ExqBatch.Middleware","type":"module"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.after_failed_work/1.","ref":"ExqBatch.Middleware.html#after_failed_work/1","title":"ExqBatch.Middleware.after_failed_work/1","type":"function"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.after_processed_work/1.","ref":"ExqBatch.Middleware.html#after_processed_work/1","title":"ExqBatch.Middleware.after_processed_work/1","type":"function"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.before_work/1.","ref":"ExqBatch.Middleware.html#before_work/1","title":"ExqBatch.Middleware.before_work/1","type":"function"},{"doc":"ExqBatchExqBatch provides a building block to create complex workflows using Exq jobs. A batch monitors a group of Exq jobs and creates callback job when all the jobs are processed.","ref":"readme.html","title":"ExqBatch","type":"extras"},{"doc":"{:ok, batch} = ExqBatch.new(on_complete: [queue: &quot;default&quot;, class: CompletionWorker, args: [&quot;complete&quot;]]) {:ok, batch, jid} = ExqBatch.add(batch, queue: &quot;default&quot;, class: Worker, args: [1]) {:ok, batch, jid} = ExqBatch.add(batch, queue: &quot;default&quot;, class: Worker, args: [2]) {:ok, _batch} = ExqBatch.create(batch)Checkout documentation for more information.","ref":"readme.html#example","title":"ExqBatch - Example","type":"extras"},{"doc":"config :exq, middleware: [ Exq.Middleware.Stats, ExqBatch.Middleware, Exq.Middleware.Job, Exq.Middleware.Manager, Exq.Middleware.Logger ]ExqBatch.Middleware middleware must be added before the Exq.Middleware.Job middleware. The middleware is used to track job life cycle.config :exq_batch, # TTL of a batch job. Under normal condition, batch will get deleted # on completion. If a batch failed to complete for any reason, it # will get deleted after TTL seconds ttl_in_seconds: 60 * 60 * 24 * 30, # All the data related to batch will be stored under the prefix in redis prefix: &quot;exq_batch&quot;, # Optional. If present, batch middleware will be enabled only for # the given queues. If not present, will be enabled for all queues. queues: [&quot;default&quot;]","ref":"readme.html#config","title":"ExqBatch - Config","type":"extras"},{"doc":"The completion job will get enqueued only once after all the jobs in a group is either done or dead. A Resurrected job does not belong to the batch and will not lead to creation of completion job.All the jobs in a batch must be allowed to be complete (either dead or done). Deleting any jobs while they are in retry queue will cause the batch to get stuck and will expire eventually.","ref":"readme.html#caveats","title":"ExqBatch - Caveats","type":"extras"}]